
#define BIOS_SIZE 0xffff

#define VARIABLE -1

#ifndef DEBUGLEVEL
#define DEBUGLEVEL 4
#endif

#define DEBUGPRINT(level, text, ...) \
if (level <= DEBUGLEVEL) \
    printf("DEBUG (%d) (%s:%d) %s(): " text, level, __FILE__, __LINE__, __func__, ## __VA_ARGS__) \

#define DEBUGPRINT(level, text, ...) \
if (level <= DEBUGLEVEL) \
    printf("DEBUG (%d): " text, level, ## __VA_ARGS__) \

typedef struct {
    unsigned char *data;
    unsigned int length;
} bios_t;

typedef struct {
    char *name;
    unsigned char id;
    int length;
    void (*handler)(bios_t *, unsigned int);
    int used;
} init_tbl_entry_t;

typedef struct {
    unsigned char id[2];
    unsigned short length;
    unsigned short offset;
} bit_entry_t;

